#!/bin/bash
# $Id: audacity.SlackBuild,v 1.27 2025/01/19 14:02:57 root Exp root $
# Copyright 2010, 2019, 2020, 2021, 2022, 2025  Eric Hameleers, Eindhoven, NL
# All rights reserved.
#
#   Permission to use, copy, modify, and distribute this software for
#   any purpose with or without fee is hereby granted, provided that
#   the above copyright notice and this permission notice appear in all
#   copies.
#
#   THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
#   WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#   MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
#   IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
#   USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
#   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#   SUCH DAMAGE.
# -----------------------------------------------------------------------------
#
# Slackware SlackBuild script 
# ===========================
# By:          Eric Hameleers <alien@slackware.com>
# For:         audacity
# Descr:       multi-track audio editor and recorder
# URL:         https://audacityteam.org
# Build needs: 
# Needs:       jack2, ladspa_sdk, libsbsms, lilv, lv2, portaudio, portmidi,
#              portsmf, serd, sord, soundtouch, soxr, sratom, suil,
#              twolame, vamp-plugin-sdk, vst3sdk, wxWidgets
# Changelog:   
# 1.3.12-1:    12/Apr/2010 by Eric Hameleers <alien@slackware.com>
#              * Initial build.
# 1.3.12-2:    31/may/2010 by Eric Hameleers <alien@slackware.com>
#              * Rebuild for Slackware 13.1
# 2.2.2-1:     22/Feb/2019 by Eric Hameleers <alien@slackware.com>
#              * Overdue update.
# 2.3.3-1:     27/nov/2019 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 2.4.1-1:     28/may/2020 by Eric Hameleers <alien@slackware.com>
#              * Update. Do not use the new 'cmake' configuration yet,
#                because it is way too buggy.
# 2.4.2-1:     27/jun/2020 by Eric Hameleers <alien@slackware.com>
#              * Update. Use cmake, and an internal patched wxGTK3.
# 2.4.2-2:     09/oct/2020 by Eric Hameleers <alien@slackware.com>
#              * Added X-DAW category to desktop file.
# 3.0.0-1:     18/mar/2021 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 3.0.2-1:     22/apr/2021 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 3.0.2-2:     19/aug/2021 by Eric Hameleers <alien@slackware.com>
#              * Fix 'internal database error' when saving a project on exit.
# 3.1.3-1:     18/sep/2022 by Eric Hameleers <alien@slackware.com>
#              * Update. Don't use conan, instead provide all the external
#                dependencies ourselves.
#                Audacity on Linux can now use vanilla wxWidgets >= 3.1.3,
#                as long as wx is provided as dynamic libraries.
#                Also, portsmf version 234 (static library this time) is
#                mandatory, since audacity won't link against newer releases.
# 3.2.1-1:     10/oct/2022 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 3.2.2-1:     18/dec/2022 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 3.6.4-1:     05/jan/2025 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 3.7.1-1:     05/jan/2025 by Eric Hameleers <alien@slackware.com>
#              * Update.
# 
# Run 'sh audacity.SlackBuild' to build a Slackware package.
# The package (.t?z) and .txt file as well as build logs are created in /tmp .
# Install the package using 'installpkg' or 'upgradepkg --install-new'.
#
# -----------------------------------------------------------------------------

PRGNAM=audacity
VERSION=${VERSION:-3.7.1}
BUILD=${BUILD:-1}
NUMJOBS=${NUMJOBS:-" -j$(nproc) "}
TAG=${TAG:-alien}
PKGTYPE="txz"

DOCS="*.txt"

# Where do we look for sources?
SRCDIR=$(cd $(dirname $0); pwd)

# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
TMP=${TMP:-/tmp/build}
PKG=$TMP/package-$PRGNAM
OUTPUT=${OUTPUT:-/tmp}

SOURCE[0]="$SRCDIR/${PRGNAM}-sources-${VERSION}.tar.gz"
SRCURL[0]="https://github.com/${PRGNAM}/${PRGNAM}/releases/download/${PRGNAM^}-${VERSION}/${PRGNAM}-sources-${VERSION}.tar.gz"

SOURCE[1]="$SRCDIR/${PRGNAM}-manual-${VERSION}.tar.xz"
SRCURL[1]="https://github.com/${PRGNAM}/${PRGNAM}/releases/download/${PRGNAM^}-${VERSION}/${PRGNAM}-manual-${VERSION}.tar.gz"

# Use the src_checkout() function if no downloadable tarball exists.
# Check out sources from GIT and create a tarball of them.
# Examples for GIT and SVN repositories are given below:
src_checkout() {
  # Param #1 : index in the SOURCE[] array.
  # Param #2 : full path to where SOURCE[$1] tarball should be created.
  # Determine the tarball extension:
  PEXT=$(echo "${2}" | sed -r -e 's/.*[^.].(tar.xz|tar.gz|tar.bz2|tgz).*/\1/')
  case "$PEXT" in
    "tar.xz") TARCOMP="J" ;;
    "tar.gz") TARCOMP="z" ;;
    "tgz") TARCOMP="z" ;;
    "tar.bz2") TARCOMP="j" ;;
    *) echo "Archive can only have extension 'tar.xz', '.tar.gz' '.tar.bz2' or '.tgz'" ; exit 1 ;;
  esac
  # Determine the directory name to create for the archive root:
  PBASE=$(basename ${2} .${PEXT})
  # Determine the directory where we create our checkout:
  CODIR=$(dirname ${2})
  case ${1} in
  1) # This example assumes a GIT checkout:
     GITURI="https://github.com/audacity/wxWidgets"
     RETDIR=$(pwd)
     mkdir -p $CODIR/${PRGNAM}_temp_checkout_$$ \
       && cd $CODIR/${PRGNAM}_temp_checkout_$$
     mkdir ${PBASE} \
       && cd ${PBASE}
     echo "Checking out from '$GITURI':"
     git clone --depth 1 --single-branch --recurse-submodules ${GITURI} . \
       && chown -R root:root . \
       && cd .. \
       && tar -${TARCOMP}cf ${2} ${PBASE}
     cd $RETDIR
     rm -rf $CODIR/${PRGNAM}_temp_checkout_$$ || true
     ;;
  *) # Do nothing
     ;;
  esac
}

##
## --- with a little luck, you won't have to edit below this point --- ##
##

# Automatically determine the architecture we're building on:
if [ -z "$ARCH" ]; then
  case "$(uname -m)" in
    i?86) ARCH=i686 ;;
    arm*) readelf /usr/bin/file -A | egrep -q "Tag_CPU.*[4,5]" && ARCH=arm || ARCH=armv7hl ;;
    # Unless $ARCH is already set, use uname -m for all other archs:
    *) ARCH=$(uname -m) ;;
  esac
  export ARCH
fi
# Set CFLAGS/CXXFLAGS and LIBDIRSUFFIX:
case "$ARCH" in
  i?86)      SLKCFLAGS="-O2 -march=${ARCH} -mtune=i686"
             SLKLDFLAGS=""; LIBDIRSUFFIX=""
             ;;
  x86_64)    SLKCFLAGS="-O2 -fPIC"
             SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
             ;;
  armv7hl)   SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16"
             SLKLDFLAGS=""; LIBDIRSUFFIX=""
             ;;
  *)         SLKCFLAGS=${SLKCFLAGS:-"-O2"}
             SLKLDFLAGS=${SLKLDFLAGS:-""}; LIBDIRSUFFIX=${LIBDIRSUFFIX:-""}
             ;;
esac

case "$ARCH" in
    arm*)    TARGET=$ARCH-slackware-linux-gnueabi ;;
    *)       TARGET=$ARCH-slackware-linux ;;
esac

# Exit the script on errors:
set -e
trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
# Catch unitialized variables:
set -u
P1=${1:-1}

# Save old umask and set to 0022:
_UMASK_=$(umask)
umask 0022

# Create working directories:
mkdir -p $OUTPUT          # place for the package to be saved
mkdir -p $TMP/tmp-$PRGNAM # location to build the source
mkdir -p $PKG             # place for the package to be built
rm -rf $PKG/*             # always erase old package's contents
rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
rm -rf $OUTPUT/{checkout,configure,make,install,error,makepkg,patch}-$PRGNAM.log
                          # remove old log files

# Source file availability:
for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
  if ! [ -f ${SOURCE[$i]} ]; then
    echo "Source '$(basename ${SOURCE[$i]})' not available yet..."
    # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
    [ -w "$SRCDIR" ] || SOURCE[$i]="$OUTPUT/$(basename ${SOURCE[$i]})"
    if [ -f ${SOURCE[$i]} ]; then echo "Ah, found it!"; continue; fi
    if ! [ "x${SRCURL[$i]}" == "x" ]; then
      echo "Will download file to $(dirname $SOURCE[$i])"
      wget --no-check-certificate -nv -T 20 -O "${SOURCE[$i]}" "${SRCURL[$i]}" || true
      if [ $? -ne 0 -o ! -s "${SOURCE[$i]}" ]; then
        echo "Fail to download '$(basename ${SOURCE[$i]})'. Aborting the build."
        mv -f "${SOURCE[$i]}" "${SOURCE[$i]}".FAIL
        exit 1
      fi
    else
      # Try if we have a GIT download routine for ${SOURCE[$i]}
      echo "Will checkout sources to $(dirname $SOURCE[$i])"
      src_checkout $i "${SOURCE[$i]}" \
        2>&1 > $OUTPUT/checkout-$(basename ${SOURCE[$i]}).log
    fi
    if [ ! -f "${SOURCE[$i]}" -o ! -s "${SOURCE[$i]}" ]; then
      echo "File '$(basename ${SOURCE[$i]})' not available. Aborting the build."
      exit 1
    fi
  fi
done

if [ "$P1" == "--download" ]; then
  echo "Download complete."
  exit 0
fi

# --- PACKAGE BUILDING ---

echo "++"
echo "|| $PRGNAM-$VERSION"
echo "++"

cd $TMP/tmp-$PRGNAM
echo "Extracting the source archive(s) for $PRGNAM..."
tar -xf ${SOURCE[0]}
cd ${PRGNAM}*-${VERSION} || cd ${PRGNAM^}*-${VERSION}

# Patches and fixes:
touch $OUTPUT/patch-${PRGNAM}.log

# Fix vamp plugin search path on x86_64 - thanks to B. Watson
sed -e "s,lib/vamp,lib${LIBDIRSUFFIX}/vamp,g" \
  -i lib-src/libvamp/src/vamp-hostsdk/PluginHostAdapter.cpp

# Fix building with GCC11:
cat $SRCDIR/patches/audacity-3.0.2_gcc11.patch | patch -p1 --verbose \
  2>&1 | tee -a $OUTPUT/patch-${PRGNAM}.log

# Don't enable VST3 support on 32bit. Also, use right assembly code:
if [ "$ARCH" == "x86_64" ]; then
  export EXTRA_CFLAGS=" "
  export VST3SDK="/usr/include/vst3sdk"
  OPTS_VST3=" -Daudacity_use_vst=yes -Daudacity_has_vst3=yes -Daudacity_use_vst3sdk=system "
else
  export EXTRA_CFLAGS="-mfpmath=sse -msse2"
  OPTS_VST3=" -Daudacity_has_vst3=no -Daudacity_use_vst=no "
fi

chown -R root:root .
chmod -R u+w,go+r-w,a+rX-st .

echo Building ...
mkdir build-$PRGNAM
pushd build-$PRGNAM
  export LDFLAGS="$SLKLDFLAGS -Wl,-rpath,/usr/lib${LIBDIRSUFFIX}/${PRGNAM}"
  export CXXFLAGS="$SLKCFLAGS"
  export CFLAGS="$SLKCFLAGS"
  cmake .. \
    -DCMAKE_BUILD_TYPE=Release \
    -DAUDACITY_BUILD_LEVEL=2 \
    -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS $EXTRA_CFLAGS" \
    -DCMAKE_C_FLAGS_RELEASE:STRING="$SLKCFLAGS $EXTRA_CFLAGS" \
    -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS $EXTRA_CFLAGS -DHAVE_VISIBILITY=1" \
    -DCMAKE_CXX_FLAGS_RELEASE:STRING="$SLKCFLAGS $EXTRA_CFLAGS -DHAVE_VISIBILITY=1" \
    -DCMAKE_INSTALL_DOCDIR=/usr/doc/$PRGNAM-$VERSION \
    -DCMAKE_INSTALL_LIBDIR=lib${LIBDIRSUFFIX} \
    -DCMAKE_INSTALL_MANDIR=/usr/man \
    -DCMAKE_INSTALL_PREFIX=/usr \
    -DCMAKE_VERBOSE_MAKEFILE:BOOL="ON" \
    -Daudacity_conan_enabled:BOOL="OFF" \
    -Daudacity_has_crashreports:BOOL="OFF" \
    -Daudacity_has_networking:BOOL="OFF" \
    -Daudacity_has_sentry_reporting:BOOL="OFF" \
    -Daudacity_has_updates_check:BOOL="OFF" \
    -Daudacity_obey_system_dependencies:BOOL="ON" \
    -Daudacity_lib_preference="system" \
    -Daudacity_use_expat=system \
    -Daudacity_use_ffmpeg=loaded \
    -Daudacity_use_ladspa:BOOL="ON" \
    -Daudacity_use_lame=system \
    -Daudacity_use_lv2=system \
    -Daudacity_use_portaudio=system \
    -Daudacity_use_sqlite=system \
    -Daudacity_use_twolame=system \
    -Daudacity_use_vamp=system \
    -Daudacity_use_wxwidgets=system \
    -DwxWidgets_CONFIG_EXECUTABLE=/usr/bin/wx-config-gtk3 \
    -DwxWidgets_wxrc_EXECUTABLE=/usr/bin/wxrc \
    ${OPTS_VST3} \
  2>&1 | tee $OUTPUT/configure-${PRGNAM}.log
    #-DCMAKE_CXX_STANDARD=11 \

  make $NUMJOBS 2>&1 | tee $OUTPUT/make-${PRGNAM}.log
  make DESTDIR=$PKG install 2>&1 | tee $OUTPUT/install-${PRGNAM}.log
popd

# Install libnyquist plugins and related files, this is broken since 2.4.0:
install -vDm 644 plug-ins/*.ny -t ${PKG}/usr/share/${PRGNAM}/plug-ins
install -vDm 644 nyquist/*.lsp -t ${PKG}/usr/share/${PRGNAM}/nyquist

# ldd complains if the shared libraries are not executable:
chmod 0755 ${PKG}/usr/lib${LIBDIRSUFFIX}/${PRGNAM}/*.so

# Add 'X-DAW' category to the desktop file (for liveslak):
for DESKTOPF in $PKG/usr/share/applications/*.desktop ; do
  if ! grep -q X-DAW $DESKTOPF ; then
    sed -i $DESKTOPF \
      -e "s/^Categories=\(.*\)/Categories=X-DAW;\1/"
  fi
done

# Add this to the doinst.sh:
mkdir -p $PKG/install
cat <<EOINS >> $PKG/install/doinst.sh
# Update the desktop database:
if [ -x usr/bin/update-desktop-database ]; then
  chroot . /usr/bin/update-desktop-database usr/share/applications > /dev/null 2>&1
fi

# Update hicolor theme cache:
if [ -d usr/share/icons/hicolor ]; then
  if [ -x /usr/bin/gtk-update-icon-cache ]; then
    chroot . /usr/bin/gtk-update-icon-cache -f -t usr/share/icons/hicolor 1> /dev/null 2> /dev/null
  fi
fi

# Update the mime database:
if [ -x usr/bin/update-mime-database ]; then
  chroot . /usr/bin/update-mime-database usr/share/mime >/dev/null 2>&1
fi

EOINS

# Add documentation:
mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
tar -xf ${SOURCE[1]} -C $PKG/usr/doc/$PRGNAM-$VERSION/
cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
find $PKG/usr/doc -type f -exec chmod 644 {} \;

# Remove superfluous copy in the wrong place:
rm -rf $PKG/usr/share/doc

# Compress the man page(s):
if [ -d $PKG/usr/man ]; then
  find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
  for i in $(find $PKG/usr/man -type l -name "*.?") ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
fi

# Strip binaries (if any):
find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
  | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true

# Add a package description:
mkdir -p $PKG/install
cat $SRCDIR/slack-desc > $PKG/install/slack-desc
cat $SRCDIR/slack-required > $PKG/install/slack-required

# Build the package:
cd $PKG
makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
cd $OUTPUT
md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz}.md5
cd -
cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
cat $PKG/install/slack-required > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.dep

# Restore the original umask:
umask ${_UMASK_}

